<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    4.3
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2010 OOO "Диафан". (http://diafan.ru)
 */

if(! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Shop_view
 *
 * Шаблон модуля "Магазин"
 */
class Shop_view
{
	/**
	 * Шаблон вывода списка товаров (в группе, результатов поиска или если группировка не используется)
	 * 
	 * @param array $result сгенерированные в моделе данные
	 * @return boolean true
	 */
	public function list_($result)
	{
		//сортировка
		echo '
		<div class="shop-order">'._LANG_ORDER_BY.': '._LANG_PRICE.' '
			.$result["link_start"][1].'▲'.$result["link_finish"][1].'
			'.$result["link_start"][2].'▼'.$result["link_finish"][2].'
			'._LANG_NAME_GOOD.' '
			.$result["link_start"][3].'▲'.$result["link_finish"][3].'
			'.$result["link_start"][4].'▼'.$result["link_finish"][4].'
		</div>';

		echo '
		<div class="shop-list">
			'.(! empty($result["text"]) ? '<div class="shop-cat-text">'.$result["text"].'</div>' : '');

		if(! empty($result["img"]))
		{
			echo '<div class="shop-cat-img">';
			if(! empty($result["img"]["link"]))
			{
				echo '<a href="'.BASE_PATH_HREF.$result["img"]["link"].'">'.$result["img"]["tag"].'</a>';
			}
			elseif(! empty($result["img"]))
			{
				foreach($result["img"] as $img)
				{
					echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
				}
			}
			echo '</div>';
		}

		//ссылки на подкатегории
		if(! empty($result["children"]))
		{
			foreach($result["children"] as $child)
			{
				echo '
				<div class="shop-cat-links"><a href="'.BASE_PATH_HREF.$child["link"].'">'.$child["name"].'</a></div>
				'.($child["anons"] ? '<div class="shop-cat-text">'.$child["anons"].'</div>' : '');
				if(! empty($child["img"]))
				{
					echo '<div class="shop-cat-img">';
					if(! empty($child["img"]["link"]))
					{
						echo '<a href="'.BASE_PATH_HREF.$child["img"]["link"].'">'.$child["img"]["tag"].'</a>';
					}
					elseif(! empty($child["img"]))
					{
						foreach($child["img"] as $img)
						{
							echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
						}
					}
					echo '</div>';
				}
			}
		}

		//товары в разделе
		if(! empty($result["rows"]))
		{
			foreach($result["rows"] as $row)
			{
				echo '
				<div class="shop">';
					if(! empty($row["img"]))
					{
						echo '<div class="shop-img">';
						if(! empty($row["img"]["link"]))
						{
							echo '<a href="'.BASE_PATH_HREF.$row["img"]["link"].'">'.$row["img"]["tag"].'</a>';
						}
						elseif(! empty($row["img"]))
						{
							foreach($row["img"] as $img)
							{
								echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
							}
						}
						echo '</div>';
					}
					echo '
					<div class="shop-name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a> '.(! empty($row["show-rating"]) ? $row["show-rating"] : '').'</div>
					'.(empty($row["depend"]) && ! empty($row["price"]) ? '
					<div class="shop-price">'._LANG_PRICE.': <span class="shop-price-value">'.$row["price"].'</span> <span class="shop-price-currency">'.$result["currency"].'</span></div>' : '');
					if(! empty($row["param"]))
					{
						foreach($row["param"] as $k => $v)
						{
							echo '
							<div class="shop-param">'.$k.($v ? ': <span class="shop-param-value">'.(is_array($v) ? implode(', ',$v) : $v).'</span>' : '')."</div>\n";
						}
					}
					echo '
					<div class="shop-text">'.$row["anons"].'</div>';
					self::form($row, $result);				
					echo (! empty($row["tags"]) ? $row["tags"] : '').'
				</div>';
			}
		}

		echo Paginator_view::get($result["paginator"])

		.'<div class="clear"></div>'
		.(! empty($result["previous"]) ? '
		<div class="previous-link"><a href="'.BASE_PATH_HREF.$result["previous"]["link"].'">&larr; '.$result["previous"]["text"].'</a></div>' : '')

		.(! empty($result["next"]) ? '
		<div class="next-link"><a href="'.BASE_PATH_HREF.$result["next"]["link"].'">'.$result["next"]["text"].' &rarr;</a></div>' : '')

		.'<div class="clear"></div>'

		.(! empty($result["comments"]) ? $result["comments"] : '')
		.'
		</div>';

		return TRUE;
	}

	/**
	 * Шаблон первой страницы магазина
	 * 
	 * @param array $result сгенерированные в моделе данные
	 * @return boolean
	 */
	public function first_page($result)
	{
		if(empty($result["categories"]))
			return FALSE;

		foreach($result["categories"] as $cat_id => $cat)
		{
			echo '
			<div class="shop-list">';
				//название и описание категории
				echo '
				<h2>'.$cat["name"].'</h2>'
				.(! empty($cat["anons"]) ? '
				<div class="shop-cat-text">'.$cat["anons"].'</div>' : '');

				if(! empty($cat["img"]))
				{
					echo '<div class="shop-cat-img">';
					if(! empty($cat["img"]["link"]))
					{
						echo '<a href="'.BASE_PATH_HREF.$cat["img"]["link"].'">'.$cat["img"]["tag"].'</a>';
					}
					elseif(! empty($cat["img"]))
					{
						foreach($cat["img"] as $img)
						{
							echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
						}
					}
					echo '</div>';
				}

			//ссылки на подкатегории
			if(! empty($cat["children"]))
			{
				foreach($cat["children"] as $child)
				{
					echo '
					<div class="shop-cat-links"><a href="'.BASE_PATH_HREF.$child["link"].'">'.$child["name"].'</a></div>
					'.(! empty($child["anons"]) ? '<div class="shop-cat-text">'.$child["anons"].'</div>' : '');
					if(! empty($child["img"]))
					{
						echo '<div class="shop-cat-img">';
						if(! empty($child["img"]["link"]))
						{
							echo '<a href="'.BASE_PATH_HREF.$child["img"]["link"].'">'.$child["img"]["tag"].'</a>';
						}
						elseif(! empty($child["img"]))
						{
							foreach($child["img"] as $img)
							{
								echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
							}
						}
						echo '</div>';
					}
				}
			}

			//товары в категории
			if(! empty($cat["rows"]))
			{
				foreach($cat["rows"] as $row)
				{
				echo '<div class="shop">';
					if(! empty($row["img"]))
					{
						echo '<div class="shop-img">';
						if(! empty($row["img"]["link"]))
						{
							echo '<a href="'.BASE_PATH_HREF.$row["img"]["link"].'">'.$row["img"]["tag"].'</a>';
						}
						elseif(! empty($row["img"]))
						{
							foreach($row["img"] as $img)
							{
								echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
							}
						}
						echo '</div>';
					}
					echo '
					<div class="shop-name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a> '.(! empty($row["show-rating"]) ? $row["show-rating"] : '').'</div>
					'.(empty($row["depend"]) && ! empty($row["price"]) ? '<div class="shop-price">'._LANG_PRICE.': <span class="shop-price-value">'.$row["price"].'</span> <span class="shop-price-currency">'.$result["currency"].'</span></div>' : '');
					if(! empty($row["param"]))
					{
						foreach($row["param"] as $k => $v)
						{
							echo '
							<div class="shop-param">'.$k.($v ? ': <span class="shop-param-value">'.(is_array($v) ? implode(', ',$v) : $v).'</span>' : '')."</div>\n";
						}
					}
					echo '
					<div class="shop-text">'.$row["anons"].'</div>';
					self::form($row, $result);				
					echo (! empty($row["tags"]) ? $row["tags"] : '').'
				</div>';
				}
			}
			//ссылка на все товары в категории
			echo ($cat["allshop"] ? '
			      <div class="show-all"><a href="'.BASE_PATH_HREF.$cat["allshop"]["link"].'">'.$cat["allshop"]["text"].'</a></div>' : '')
			.'
			</div>';
		}

		return TRUE;
	}

	/**
	 * Шаблон страницы товара
	 * 
	 * @param array $row данные о товаре
	 * @return boolean true
	 */
	public function id($row)
	{	
		echo '
		<div class="shop-id">'
			//рейтинг товара
			.(! empty($row["show-rating"]) ? $row["show-rating"] : '')
			
			//форма оценки товара
			.(! empty($row["add-rating"]) ? $row["add-rating"] :'')

			.(empty($row["depend"]) && ! empty($row["price"]) ? '<div class="shop-price">'._LANG_PRICE.': <span class="shop-price-value">'.$row["price"].'</span> <span class="shop-price-currency">'.$row["currency"].'</span></div>' : '');
			self::form($row, $row);
			if(! empty($row["param"]))
			{
				foreach($row["param"] as $k => $v)
				{
					echo '
					<div class="shop-param">'.$k.($v ? ': <span class="shop-param-value">'.(is_array($v) ? implode(', ',$v) : $v).'</span>' : '')."</div>\n";
				}
			}
			echo 
			//анонс
			($row["anons"] ? '<div class="shop-anons">'.$row["anons"].'</div>' : '')

			//описание
			.'<div class="shop-text">'.$row["text"].'</div>';
			if(! empty($row["img"]))
			{
				echo '<div class="shop-all-img">';
				if(! empty($row["img"]["link"]))
				{
					echo '<a href="'.BASE_PATH.$row["img"]["link"].'">'.$row["img"]["tag"].'</a>';
				}
				elseif(! empty($row["img"]))
				{
					foreach($row["img"] as $img)
					{
						echo ' <a href="'.BASE_PATH.$img["link"].'">'.$img["tag"].'</a>';
					}
				}
				echo '</div>';
			}
			echo (! empty($row["tags"]) ? $row["tags"] : '')

			.(! empty($row["previous"]) ? '
		        <div class="previous-link"><a href="'.BASE_PATH_HREF.$row["previous"]["link"].'">&larr; '.$row["previous"]["text"].'</a></div>' : '')

			.(! empty($row["next"]) ? '
		        <div class="next-link"><a href="'.BASE_PATH_HREF.$row["next"]["link"].'">'.$row["next"]["text"].' &rarr;</a></div>' : '').'

			<div class="clear"></div>
		</div>'

		.(! empty($row["comments"]) ? $row["comments"] : '');

		return TRUE;
	
	}

	/**
	 * Шаблонная функция: блок товаров
	 * 
	 * @param array $result сгенерированные в моделе данные
	 * @return boolean true
	 */
	public function show_block($result)
	{
		echo '<div class="shop-block">';
		//название и описание раздела
		echo (! empty($result["name"]) ? '<h2>'.$result["name"].'</h2>' : '');
		//товары в разделе
		if(! empty($result["rows"]))
		{
			foreach($result["rows"] as $row)
			{
				echo '
				<div class="shop">
					<div class="shop-name"><a href="'.BASE_PATH_HREF.$row["link"].'">'.$row["name"].'</a></div>';
					if(! empty($row["img"]))
					{
						echo '<div class="shop-img">';
						if(! empty($row["img"]["link"]))
						{
							echo '<a href="'.BASE_PATH_HREF.$row["img"]["link"].'">'.$row["img"]["tag"].'</a>';
						}
						elseif(! empty($row["img"]))
						{
							foreach($row["img"] as $img)
							{
								echo ' <a href="'.BASE_PATH_HREF.$img["link"].'">'.$img["tag"].'</a>';
							}
						}
						echo '</div>';
					}
					echo (empty($row["depend"]) && ! empty($row["price"]) ? '<div class="shop-price">'._LANG_PRICE.': <span class="shop-price-value">'.$row["price"].'</span> <span class="shop-price-currency">'.$result["currency"].'</span></div>' : '');
					self::form($row, $result);
					if(! empty($row["param"]))
					{
						foreach($row["param"] as $k => $v)
						{
							echo '
							<div class="shop-param">'.$k.($v ? ': <span class="shop-param-value">'.(is_array($v) ? implode(', ',$v) : $v).'</span>' : '')."</div>\n";
						}
					}
					echo (! empty($row["anons"]) ? '
					<div class="shop-text">'.$row["anons"].'</div>' : '').'
				</div>';
			}
		}

		//ссылка на все товары
		echo (! empty($result["allshop"]) ? '
		      <div class="show-all"><a href="'.BASE_PATH_HREF.$result["allshop"]["link"].'">'.$result["allshop"]["text"].'</a></div>' : '').'
		</div>';

		return TRUE;
		
	}

	/**
	 * Шаблонная функция: форма поиска по товарам
	 * 
	 * @param array $result сгенерированные в моделе данные
	 * @return boolean true
	 */
	public function show_search($result)
	{
		echo '
		<div class="shop-search">
		<h2>'._LANG_SEARCH_GOODS.'</h2>
			<form method="get" action="'.BASE_PATH_HREF.$result["path"].'">
			<input type="hidden" value="'.$result["cat_id"].'" name="catid">';

		if(! empty($result["name"]))
		{
			echo '
			<div class="shop-search-name">
				<span class="infofield">'._LANG_NAME.':</span>
				<input type="text" name="n" size="20" value="'.$result["name"]["value"].'" class="inptext">
			</div>';
		}

		if(! empty($result["text"]))
		{
			echo '
			<div class="shop-search-description">
				<span class="infofield">'._LANG_DESCRIPTION.':</span>
				<input type="text" name="d" size="20" value="'.$result["text"]["value"].'" class="inptext">
			</div>';
		}

		if(! empty($result["price"]))
		{
			echo '
			<div class="shop-search-price">
				<span class="infofield">'._LANG_PRICE.':</span> 
				'._LANG_FROM.' <input type="text" name="pr1" size="5" value="'.$result["price"]["value1"].'" class="inpnum"> '
				._LANG_TO.' <input type="text" name="pr2" size="5" value="'.$result["price"]["value2"].'" class="inpnum">
			</div>';
		}

		if(! empty($result["rows"]))
		{
			foreach($result["rows"] as $row)
			{
				echo '
				<div class="param'.$row["id"].'">';
				if ($row["type"] == 'text' || $row["type"] == 'textarea' || $row["type"] == 'editor')
				{
					echo '
					<span class="infofield">'.$row["name"].':</span>
					<input type="text" name="p'.$row["id"].'" size="20" value="'.$row["value"].'" class="inptext">';
				}
				elseif ($row["type"] == 'date')
				{
					echo '
					<span class="infofield">'.$row["name"].':</span>
					    '._LANG_FROM.'
					    
					    <input type="text" name="p'.$row["id"].'d1" size="1" value="'.$row["d1"].'"
					    onClick="this.value=\'\'" class="inpnum">
					    
					    <input type="text" name="p'.$row["id"].'m1" size="1" value="'.$row["m1"].'"
					    onClick="this.value=\'\'" class="inpnum">
					    
					    <input type="text" name="p'.$row["id"].'y1" size="2" value="'.$row["y1"].'"
					    onClick="this.value=\'\'" class="inpnum"> 
					    
					    '._LANG_TO.'
					    
					    <input type="text" name="p'.$row["id"].'d2" size="1" value="'.$row["d1"].'"
					    onClick="this.value=\'\'" class="inpnum">
					    
					    <input type="text" name="p'.$row["id"].'m2" size="1" value="'.$row["m2"].'"
					    onClick="this.value=\'\'" class="inpnum">
					    
					    <input type="text" name="p'.$row["id"].'y2" size="2" value="'.$row["y1"].'"
					    onClick="this.value=\'\'" class="inpnum">';
				}
				elseif ($row["type"] == 'numtext')
				{
				    echo '
				    <span class="infofield">'.$row["name"].':</span>
				    '._LANG_FROM.' <input type="text" name="p'.$row["id"].'_1" size="5" value="'
				    .$row["value1"].'" class="inpnum"> 
				    
				    '._LANG_TO.' <input type="text" name="p'.$row["id"].'_2" size="5" value="'
				    .$row["value2"].'" class="inpnum">';
				}
				elseif ($row["type"] == 'checkbox')
				{
					echo '
					<span class="infofield">'.$row["name"].':</span>
					<input type="checkbox" name="p'.$row["id"].'" value="1"'.($row["value"] ? " checked" : '').' class="inpcheckbox">';
				}
				elseif ($row["type"] == 'select')
				{
					echo '
					<span class="infofield">'.$row["name"].':</span>
					<select name="p'.$row["id"].'" class="inpselect">
						<option value="">-</option>';
					foreach ($row["select_array"] as $key => $value)
					{
						echo '
						<option value="'.$key.'"'.($row["value"] == $key ? " selected" : '').'>'.$value.'</option>';
					}
					echo '
					</select>';
				}
				elseif ($row["type"] == 'multiple')
				{
					echo '
					<span class="infofield">'.$row["name"].':</span>
					<select name="p'.$row["id"].'[]" class="inpselect" multiple="multiple">
						<option value="">-</option>';
					foreach ($row["select_array"] as $key => $value)
					{
						echo '
						<option value="'.$key.'"'.(in_array($key, $row["value"]) ? " selected" : '').'>'.$value.'</option>';
					}
					echo '
					</select>';
				}
				echo '
				</div>';
			}
		}
		echo '
			<input type="submit" value="'._LANG_SEARCH.'" class="button">
			</form>
		</div>';

		return TRUE;
	}

	/**
	 * Шаблон вывода кнопки "Купить", в котором характеристики, влияющие на цену выводятся в виде выпадающего списка
	 * 
	 * @param integer $row данные о товаре
	 * @param array $result сгенерированные в моделе данные
	 * @return boolean
	 */
	private function form($row, $result)
	{
		if(! $result["buy"])
			return FALSE;

		echo '
		<form method="post" action="'.(isset($result["action"]) ? BASE_PATH_HREF.$result["action"] : '').'" class="shop-form ajax">
		<input type="hidden" name="addshop" value="'.$row["id"].'">
		<input type="hidden" name="ajax" value="">';

		if(! empty($row["param_select_buy"]))
		{
			foreach($row["param_select_buy"] as $id => $rows)
			{
				$depends = $result["depends"][$id];
				echo '
				<div class="shop-form-param">
					'.$depends["name"].':
					<select name="param'.$id.'" class="inpselect">
						<option value="" rel="">-</option>';
				foreach($rows as $r)
				{
					echo '
						<option value="'.$r["value"].'"'.($r["selected"] ? ' selected' : '').'>'.$depends["values"][$r["value"]].'</option>';
				}
				echo '</select>
				</div>';
			}
		}

		if($row["depend"])
		{
			$depends = $result["depends"][$row["depend"]["param_id"]];
			echo $depends["name"].': <select name="depend" class="inpselect">
				<option value="" rel="">-</option>';
			foreach($row["depend"]["rows"] as $r)
			{
				echo '
				<option value="'.$r["value"].'" rel="'.$r["price"].' '.$result["currency"].'"'.($r["selected"] ? ' selected' : '').'>'.$depends["values"][$r["value"]].'</option>';
			}
			echo '</select>
			<span class="shop-price-depend">'.($row["price"] ? $row["price"].' '.$result["currency"] : '').'</span>';
		}
		echo '
		<input type="text" class="inpnum" value="1" name="count" size="1">
		<input type="submit" class="button" value="'._LANG_BUY.'">
		<div class="errors error"'.($row["error"] ? '>'.$row["error"] : ' style="display:none">').'</div>
		</form>';

		return TRUE;
	}

	/**
	 * Шаблон вывода кнопки "Купить", в котором каждой характеристике, влияющей на цену выведена отдельная кнопка "Купить"
	 * чтобы использовать шаблон, переименуйте фунцию в form, а функцию form (строка 335) в form_
	 * 
	 * @param integer $row данные о товаре
	 * @param array $result сгенерированные в моделе данные
	 * @return boolean
	 */
	private function form_($row, $result)
	{
		if(! $result["buy"])
			return FALSE;

		if($row["depend"])
		{
			$depends = $result["depends"][$row["depend"]["param_id"]];
			foreach($row["depend"]["rows"] as $r)
			{
				echo '
				<form method="post" action="'.(! empty($result["action"]) ? $result["action"] : '').'" class="shop-form ajax">
					<input type="hidden" name="addshop" value="'.$row["id"].'">
					<input type="hidden" name="depend" value="'.$r["value"].'">
					<input type="hidden" name="ajax" value="">';

					if(! empty($row["param_select_buy"]))
					{
						foreach($row["param_select_buy"] as $id => $rows)
						{
							$deps = $result["depends"][$id];
							echo '
							<div class="shop-form-param">
								'.$deps["name"].':
								<select name="param'.$id.'" class="inpselect">
									<option value="" rel="">-</option>';
							foreach($rows as $rs)
							{
								echo '
									<option value="'.$rs["value"].'"'.($rs["selected"] ? ' selected' : '').'>'.$deps["values"][$rs["value"]].'</option>';
							}
							echo '</select>
							</div>';
						}
					}

					echo $depends["name"].': '.$depends["values"][$r["value"]]
					.' <span class="shop-price-depend">'.$r["price"].' '.$result["currency"].'</span>

					<input type="submit" class="button" value="'._LANG_BUY.'">

					<div class="errors error"'
					.($row["error"] && $row["depend"][0] == $r ? '>'.$row["error"] : ' style="display:none">')
					.'</div>
				</form>';
			}
		}
		else
		{
			echo '
			<form method="post" action="'.(isset($result["action"]) ? BASE_PATH_HREF.$result["action"] : '').'" class="shop-form ajax">
			<input type="hidden" name="addshop" value="'.$row["id"].'">
			<input type="hidden" name="ajax" value="">';
	
			if(! empty($row["param_select_buy"]))
			{
				foreach($row["param_select_buy"] as $id => $rows)
				{
					$depends = $result["depends"][$id];
					echo '
					<div class="shop-form-param">
						'.$depends["name"].':
						<select name="param'.$id.'" class="inpselect">
							<option value="" rel="">-</option>';
					foreach($rows as $r)
					{
						echo '
							<option value="'.$r["value"].'"'.($r["selected"] ? ' selected' : '').'>'.$depends["values"][$r["value"]].'</option>';
					}
					echo '</select>
					</div>';
				}
			}
			echo '
			<input type="text" class="inpnum" value="1" name="count" size="1">
			<input type="submit" class="button" value="'._LANG_BUY.'">
			<div class="errors error"'.($row["error"] ? '>'.$row["error"] : ' style="display:none">').'</div>
			</form>';
		}

		return TRUE;
	}
}